;;; Window Functions

;;; 3.1  Visual Types

(extern VisualID "XVisualIDFromVisual" (Visual* visual))

;;; 3.3  Creating Windows

(extern Window "XCreateWindow"
	(Display* dpy)
	(Window parent)
	(int x) (int y)
	(unsignedint width) (unsignedint height)
	(unsignedint borderWidth)
	(int depth)
	(unsignedint class)
	(Visual* visual)
	(unsignedlong valuemask)
	(XSetWindowAttributes* attributes))

(extern Window "XCreateSimpleWindow"
	(Display* dpy)
	(Window parent)
	(int x) (int y)
	(unsignedint width) (unsignedint height)
	(unsignedint borderWidth)
	(unsignedlong border)
	(unsignedlong background))

;;; 3.4  Destroying Windows

(extern void "XDestroyWindow" (Display* dpy) (Window w))

(extern void "XDestroySubwindows" (Display* dpy) (Window win))

;;; 3.5  Mapping Windows

(extern void "XMapWindow" (Display* dpy) (Window w))

(extern void "XMapRaised" (Display* dpy) (Window w))

(extern void "XMapSubwindows" (Display* dpy) (Window win))

;;; 3.6  Unmapping Windows

(extern void "XUnmapWindow" (Display* dpy) (Window w))

(extern void "XUnmapSubwindows" (Display* dpy) (Window win))

;;; 3.7  Configuring Windows

(extern void "XConfigureWindow"
	(Display* dpy)
	(Window w)
	(unsignedint mask)
	(XWindowChanges* changes))

(extern void "XMoveWindow" (Display* dpy) (Window w) (int x) (int y))

(extern void "XResizeWindow"
	(Display* dpy)
	(Window w)
	(unsignedint width)
	(unsignedint height))

(extern void "XMoveResizeWindow"
	(Display* dpy)
	(Window w) (int x) (int y)
	(unsignedint width) (unsignedint height))

(extern void "XSetWindowBorderWidth"
	(Display* dpy)
	(Window w)
	(unsignedint width))

;;; 3.8  Changing Window Stacking Order

(extern void "XRaiseWindow" (Display* dpy) (Window w))

(extern void "XLowerWindow" (Display* dpy) (Window w))

(extern void "XCirculateSubwindows"
	(Display* dpy)
	(Window w)
	(int direction))

(extern void "XCirculateSubwindowsUp" (Display* dpy) (Window w))

(extern void "XCirculateSubwindowsDown" (Display* dpy) (Window w))

(extern void "XRestackWindows"
	(Display* dpy) 
	(unsignedA* windows)
	(unsigned count))

;;; 3.9  Changing Window Attributes

(extern void "XChangeWindowAttributes"
	(Display* dpy)
	(Window w)
	(unsignedlong valuemask)
	(XSetWindowAttributes* attributes))

(extern void "XSetWindowBackground"
	(Display* dpy)
	(Window w)
	(unsignedlong pixel))

(extern void "XSetWindowBackgroundPixmap"
	(Display* dpy)
	(Window w)
	(Pixmap pixmap))

(extern void "XSetWindowBorder"
	(Display* dpy)
	(Window w)
	(unsignedlong pixel))

(extern void "XSetWindowBorderPixmap"
	(Display* dpy)
	(Window w)
	(Pixmap pixmap))

(extern int "XTranslateCoordinates"
	(Display* dpy)
	(Window src_win) (Window dest_win)
	(int src_x) (int src_y)
	(out int dst_x) (out int dst_y)
	(out Window child))
