;;; Window Information Functions

;;; 4.1  Obtaining Window Information

(extern Status "XQueryTree"
	(Display* dpy)
	(Window w)
	(out Window root)
	(out Window parent)
	(out WindowA* children)
	(out unsignedint nchildren))

(extern Status "XGetWindowAttributes"
	(Display* dpy)
	(Window w)
	(out XWindowAttributes att))

(extern Status "XGetGeometry"
	(Display* dpy)
	(Drawable d)
	(out Window root)
	(out int x) (out int y)
	(out unsignedint width) (out unsignedint height)
	(out unsignedint borderWidth)
	(out unsignedint depth))

(extern Bool "XQueryPointer"
	(Display* dpy)
	(Window w)
	(out Window root) (out Window child)
	(out int root_x) (out int root_y)
	(out int win_x) (out int win_y)
	(out unsignedint mask))

;;; 4.2 Properties and Atoms

(extern Atom "XInternAtom"
	(Display* dpy)
	(string name)
	(Bool onlyIfExists))

(extern charA* "XGetAtomName" (Display* dpy) (Atom atom))

;;; 4.3 Obtaining and Changing Window Properties

(extern int "XGetWindowProperty"	;;; A wrapper might be useful here
	(Display* dpy)			;;; once we see how it is used.
	(Window w)
	(Atom property)
	(long offset) (long length)
	(Bool delete)
	(Atom req_type)
	(out Atom actual_type)
	(out int actual_format)
	(out unsignedlong nitems)
	(out unsignedlong bytesafter)
	(out charA* prop))

(extern AtomA* "XListProperties" (Display* dpy)	(Window w) (out int num_prop))

(extern void "XChangeProperty"
	(Display* dpy)
	(Window w)
	(Atom property)
	(Atom type)
	(int format)
	(int mode)
	(charA* data)
	(int nelements))

(extern void "XRotateWindowProperties"
	(Display* dpy)
	(Window w)
	(AtomA* properties)
	(int nprops)
	(int npositions))

(extern void "XDeleteProperty"
	(Display* dpy)
	(Window window)
	(Atom property))

;;; 4.4  Selections

(extern void "XSetSelectionOwner"
	(Display* dpy)
	(Atom selection)
	(Window owner)
	(Time time))

(extern Window "XGetSelectionOwner"
	(Display* dpy)
	(Atom selection))

(extern void "XConvertSelection"
	(Display* dpy)
	(Atom selection) (Atom target)
	(Atom property)
	(Window requestor)
	(Time time))
