;;; 7.1  Changing the Parent of a Window

(extern void "XReparentWindow"
	(Display* dpy)
	(Window w)
	(Window p)
	(int x)
	(int y))

;;; 7.2  Controlling the Lifetime of a Window

(extern void "XChangeSaveSet"
	(Display* dpy)
	(Window win)
	(int mode))

(extern void "XAddToSaveSet"
	(Display* dpy)
	(Window win))

(extern void "XRemoveFromSaveSet"
	(Display* dpy)
	(Window win))

;;; 7.3  Determining Resident Colormaps

(extern void "XInstallColormap"
	(Display* dpy)
	(Colormap cmap))

(extern void "XUninstallColormap"
	(Display* dpy)
	(Colormap cmap))

(extern ColormapAP "XListInstalledColormaps"
	(Display* dpy)
	(Window w)
	(out int num))

;;; 7.4  Pointer Grabbing

(extern int "XGrabPointer"
	(Display* dpy)
	(Window grab_window)
	(Bool owner_events)
	(unsignedint event_mask)
	(int pointer_mode)
	(int keyboard_mode)
	(Window confine_to)
	(Cursor curs)
	(Time time))

(extern void "XUngrabPointer"
	(Display* dpy)
	(Time time))

(extern void "XChangeActivePointerGrab"
	(Display* dpy)
	(unsignedint event_mask)
	(Cursor curs)
	(Time time))

(extern void "XGrabButton"
	(Display* dpy)
	(unsignedint button)
	(unsignedint modifiers)
	(Window grab_window)
	(Bool owner_events)
	(unsignedint event_mask)
	(int pointer_mode)
	(int keyboard_mode)
	(Window confine_to)
	(Cursor curs))

(extern void "XUngrabButton"
	(Display* dpy)
	(unsignedint button)
	(unsignedint modifiers)
	(Window grab_window))

;;; 7.5  Keyboard Grabbing

(extern int "XGrabKeyboard"
	(Display* dpy)
	(Window window)
	(Bool ownerEvents)
	(int pointerMode)
	(int keyboardMode)
	(Time time))

(extern void "XUngrabKeyboard"
	(Display* dpy)
	(Time time))

(extern void "XGrabKey"
	(Display* dpy)
	(int key)
	(unsignedint modifiers)
	(Window grab_window)
	(Bool owner_events)
	(int pointer_mode)
	(int keyboard_mode))

(extern void "XUngrabKey"
	(Display* dpy)
	(int key)
	(unsignedint modifiers)
	(Window grab_window))

(extern void "XAllowEvents"
	(Display* dpy)
	(int mode)
	(Time time))

;;; 7.6  Server Grabbing

(extern void "XGrabServer"
	(Display* dpy))

(extern void "XUngrabServer"
	(Display* dpy))

;;; 7.7.1  Controlling Input Focus

(extern void "XWarpPointer"
	(Display* dpy)
	(Window src_win)
	(Window dest_win)
	(int src_x)
	(int src_y)
	(unsignedint src_width)
	(unsignedint src_height)
	(int dest_x)
	(int dest_y))

(extern void "XSetInputFocus"
	(Display* dpy)
	(Window focus)
	(int revert_to)
	(Time time))

(extern void "XGetInputFocus"
	(Display* dpy)
	(out Window focus)
	(out int revert_to))

;;; 7.7.2  Killing Clients

(extern void "XSetCloseDownMode"
	(Display* dpy)
	(int mode))

(extern void "XKillClient"
	(Display* dpy)
	(XID resource))

;;; 7.8  Keyboard and Pointer Settings

(extern void "XChangeKeyboardControl"
	(Display* dpy)
	(unsignedlong mask)
	(XKeyboardControl* value_list))

(extern void "XGetKeyboardControl"
	(Display* dpy)
	(out XKeyboardState state))

(extern void "XAutoRepeatOn"
	(Display* dpy))

(extern void "XAutoRepeatOff"
	(Display* dpy))

(extern void "XBell"
	(Display* dpy) (int percent))

(extern void "XQueryKeymap"
	(Display* dpy)
	(out XQKeymap keys))

(extern int "XSetPointerMapping"
	(Display* dpy)
	(charA* map)
	(int nmaps))

(extern int "XGetPointerMapping"
	(Display* dpy)
	(charA* map)
	(int nmaps))

(extern void "XChangePointerControl"
	(Display* dpy)
	(Bool do_acc)
	(Bool do_thresh)
	(int acc_numerator)
	(int acc_denominator)
	(int threshold))

(extern void "XGetPointerControl"
	(Display* dpy)
	(out int accel_numer)
	(out int accel_denom)
	(out int threshold))

;;; 7.9  Keyboard Encoding 

(extern void "XDisplayKeycodes"
	(Display* dpy)
	(out int min_keycode_return)
	(out int max_keycode_return))

(extern KeySymA* "XGetKeyboardMapping"
	(Display* dpy)
	(KeyCode first_keycode)
	(int count)
	(out int keysyms_per_keycode))

(extern void "XChangeKeyboardMapping"
	(Display* dpy)
	(int first_keycode)
	(int keysyms_per_keycode)
	(KeySymA* keysyms)
	(int nkeycodes))

(extern XModifierKeymap* "XNewModifiermap"
	(int keyspermodifier))

(extern XModifierKeymap* "XInsertModifiermapEntry"
	(XModifierKeymap* map)
	(KeyCode keysym)
	(int modifier))

(extern XModifierKeymap* "XDeleteModifiermapEntry"
	(XModifierKeymap* map)
	(KeyCode keysym)
	(int modifier))

(extern void "XFreeModifiermap"
	(XModifierKeymap* map))

(extern int "XSetModifierMapping"
	(Display* dpy)
	(XModifierKeymap* modifier_map))

(extern XModifierKeymap* "XGetModifierMapping"
	(Display* dpy))

;;; 7.10  Screen Saver Control

(extern void "XSetScreenSaver"
	(Display* dpy)
	(int timeout)
	(int interval)
	(int prefer_blank)
	(int allow_exp))

(extern void "XForceScreenSaver"
	(Display* dpy)
	(int mode))

(extern void "XActivateScreenSaver"
	(Display* dpy))

(extern void "XResetScreenSaver"
	(Display* dpy))

(extern void "XGetScreenSaver"
	(Display* dpy)
	(out int timeout)
	(out int interval)
	(out int prefer_blanking)
	(out int allow_exp))

;;; 7.11.1  Adding, Getting, or Removing Hosts

(extern void "XAddHost"
	(Display* dpy)
	(XHostAddress* host))

(extern void "XAddHosts"
	(Display* dpy)
	(XHostAddressA* hosts) (int n))

(extern XHostAddressA* "XListHosts"
	(Display* dpy)
	(out int nhosts)
	(out Bool enabled))

(extern void "XRemoveHost"
	(Display* dpy)
	(XHostAddress* host))

(extern void "XRemoveHosts"
	(Display* dpy)
	(XHostAddressA* hosts)
	(int n))

;;; 7.11.2  Changing, Enabling, or Disabling Access Control

(extern void "XSetAccessControl"
	(Display* dpy)
	(int mode))

(extern void "XEnableAccessControl"
	(Display* dpy))

(extern void "XDisableAccessControl"
	(Display* dpy))
