;;; 8.5  Selecting Events

(extern void "XSelectInput"
	(Display* dpy)
	(Window w)
	(long mask))

;;; 8.6  Handling the Output Buffer

(extern void "XFlush"
	(Display* dpy))

(extern void "XSync"
	(Display* dpy)
	(Bool discard))

;;; 8.7  Event Queue Management

(extern int "XEventsQueued"
	(Display* dpy)
	(int mode))

(extern int "XPending"
	(Display* dpy))

;;; 8.8.1  Returning the Next Event

(extern void "XNextEvent"
	(Display* dpy)
	(out XEvent event))

(extern void "XPeekEvent"
	(Display* dpy)
	(out XEvent event))

;;; 8.8.2  Selecting Events Using a Predicate Procedure

(extern void "XIfEvent"
	(Display* dpy)
	(out XEvent event)
	(BoolPROC predicate)
	(char* arg))

(extern Bool "XCheckIfEvent"
	(Display* dpy)
	(out XEvent event)
	(BoolPROC predicate)
	(char* arg))

(extern void "XPeekIfEvent"
	(Display* dpy)
	(out XEvent event)
	(BoolPROC predicate)
	(char* arg))

;;; 8.8.3  Selecting Events Using a Window or Event Mask

(extern void "XWindowEvent"
	(Display* dpy)
	(Window w)
	(long mask)
	(out XEvent event))

(extern Bool "XCheckWindowEvent"
	(Display* dpy)
	(Window w)
	(long mask)
	(out XEvent event))

(extern void "XMaskEvent"
	(Display* dpy)
	(long mask)
	(out XEvent event))

(extern Bool "XCheckMaskEvent"
	(Display* dpy)
	(long mask)
	(out XEvent event))

(extern Bool "XCheckTypedEvent"
	(Display* dpy)
	(int type)
	(out XEvent event))

(extern Bool "XCheckTypedWindowEvent"
	(Display* dpy)
	(Window w)
	(int type)
	(out XEvent event))

;;; 8.9  Putting an Event Back into the Queue

(extern void "XPutBackEvent"
	(Display* dpy)
	(XEvent* event))

;;; 8.10  Sending Events to Other Applications

(extern Status "XSendEvent"
	(Display* dpy)
	(Window w)
	(Bool propagate)
	(long event_mask)
	(XEvent* event))

;;; 8.11  Getting Pointer Motion History

(extern long "XDisplayMotionBufferSize"
	(Display* dpy))

(extern XTimeCoordA* "XGetMotionEvents"
	(Display* dpy)
	(Window w)
	(Time start)
	(Time stop)
	(out int nevents))

;;; 8.12.1  Enabling or Disabling Synchronization

(extern intPROC "XSetAfterFunction"
	(Display* dpy)
	(intPROC func))

(extern intPROC "XSynchronize"
	(Display* dpy)
	(int onoff))

;;; 8.12.2  Using the Default Error Handlers

(extern void "XSetErrorHandler"
	(intPROC handler))

(extern void "XGetErrorText"
        (Display* dpy)
	(int code)
	(out char buffer)
	(int nbytes))

(extern void "XGetErrorDatabaseText"
	(Display* dpy)
	(string name)
	(string type)
	(string defaultp)
	(out char buffer)
	(int nbytes))

(extern string "XDisplayName"
	(string display))

(extern void "XSetIOErrorHandler"
	(intPROC handler))
