;;; X11 R4 extensions to xlib.  Section numbers refer to the 2nd edition
;;; of "X Window System", by Scheifler and Gettys.

;;; 2.2.1  Display Macros

(extern intA* "XListDepths" (Display* dpy) (int screen) (out int count))

;;; 2.2.2  Image Format Functions and Macros

(extern XPixmapFormatValuesA* "XListPixmapFormats"
	(Display* dpy)
	(out int count))

;;; 2.2.3  Screen Information Macros

(extern int "XScreenNumberOfScreen" (Screen* screen))

;;; 5.3  Manipulating Graphics Context/State

(extern Status "XGetGCValues"
	(Display* dpy)
	(GC gc)
	(unsignedlong value_mask)
	(out XGCValues values))

;;; 9.1.1  Manipulating Top-level Windows

(extern Status "XIconifyWindow" (Display* dpy) (Window w) (int screen))

(extern Status "XWithdrawWindow" (Display* dpy) (Window w) (int screen))

(extern Status "XReconfigureWMWindow"
	(Display* dpy)
	(Window w)
	(int screen)
	(unsigned value_mask)
	(XWindowChanges* values))

;;; 9.1.2  Converting String Lists

(extern Status "XStringListToTextProperty"
	(char*A* list)
	(int count)
	(out XTextProperty text_prop))

(extern Status "XTextPropertyToStringList"
	(XTextProperty* text_prop)
	(out char*A* list)
	(out int count))

(extern void "XFreeStringList" (char*A* list))

;;; 9.1.3  Setting and Reading Text Properties

(extern void "XSetTextProperty"
	(Display* dpy)
	(Window w)
	(XTextProperty* text_prop)
	(Atom property))

(extern Status "XGetTextProperty"
	(Display* dpy)
	(Window w)
	(out XTextProperty text_prop)
	(Atom property))

;;; 9.1.4  Setting and Reading the WM_NAME Property

(extern void "XSetWMName" (Display* dpy) (Window w) (XTextProperty* text_prop))

(extern Status "XGetWMName"
	(Display* dpy)
	(Window w)
	(out XTextProperty text_prop))

;;; 9.1.5  Setting and Reading the WM_ICON_NAME Property

(extern void "XSetWMIconName"
	(Display* dpy)
	(Window w)
	(XTextProperty* text_prop))

(extern Status "XGetWMIconName"
	(Display* dpy)
	(Window w)
	(out XTextProperty text_prop))

;;; 9.1.7  Setting and Reading the WM_NORMAL_HINTS Property

(extern void "XSetWMNormalHints" (Display* dpy) (Window w) (XSizeHints* hints))

(extern Status "XGetWMNormalHints"
	(Display* dpy)
	(Window w)
	(out XSizeHints hints)
	(out longint supplied))

(extern void "XSetWMSizeHints"
	(Display* dpy)
	(Window w)
	(XSizeHints* hints)
	(Atom property))

(extern Status "XGetWMSizeHints"
	(Display* dpy)
	(Window w)
	(out XSizeHints hints)
	(out longint supplied)
	(Atom property))

;;; 9.1.10  Setting and Reading the WM_PROTOCOLS Property

(extern Status "XSetWMProtocols"
	(Display* dpy)
	(Window w)
	(AtomA* protocols)
	(int count))

(extern Status "XGetWMProtocols"
	(Display* dpy)
	(Window w)
	(out AtomA* protocols)
	(out int count))

;;; 9.1.11  Setting and Reading the WM_COLORMAP_WINDOWS Property

(extern Status "XSetWMColormapWindows"
	(Display* dpy)
	(Window w)
	(WindowA* windows)
	(int count))

(extern Status "XGetWMColormapWindows"
	(Display* display)
	(Window w)
	(out WindowA* windows)
	(out int count))

;;; 9.1.13  Using Window Manager Convenience Functions

(extern void "XSetWMProperties"
	(Display* display)
	(Window w)
	(XTextProperty* window_name)
	(XTextProperty* icon_name)
	(char*A* argv)
	(int argc)
	(XSizeHints* normal_hints)
	(XWMHints* wm_hints)
	(XClassHint* class_hints))

(extern int "XWMGeometry"
	(Display* dpy)
	(int screen)
	(string user_geom)
	(string def_geom)
	(unsignedint bwidth)
	(XSizeHints* hints)
	(out int x)
	(out int y)
	(out int width)
	(out int height)
	(out int gravity))

;;; 9.2.1  Setting and Reading the WM_COMMAND Property

(extern Status "XGetCommand"
	(Display* dpy)
	(Window w)
	(out char*A* argv)
	(out int argc))

;;; 9.2.2  Setting and Reading the WM_CLIENT_MACHINE Property

(extern void "XSetWMClientMachine"
	(Display* dpy)
	(Window w)
	(XTextProperty* text_prop))

(extern Status "XGetWMClientMachine"
	(Display* dpy)
	(Window w)
	(out XTextProperty text_prop))

;;; 9.3.2  Setting and Obtaining Standard Colormaps

(extern void "XSetRGBColormaps"
	(Display* dpy)
	(Window w)
	(XStandardColormap* std_colormap)
	(int count)
	(Atom property))

(extern Status "XGetRGBColormaps"
	(Display* dpy)
	(Window w)
	(out XStandardColormap* std_colormap)
	(out int count)
	(Atom property))


