(extern int "shmget"
	(key_t key)
	(int size)
	(int shmflg))

(extern char* "shmat"
	(int shmid)
	(char* shmaddr)
	(int shmflg))

(extern int "shmdt"
	(char* shmaddr))

(const IPC_RMID 0)     ;; remove resource
(const IPC_SET  1)     ;; set ipc_perm options
(const IPC_STAT 2)     ;; get ipc_perm options
(const IPC_INFO 3)     ;; see ipcs

(typedef (struct (key_t  key)
		 (shortunsigned uid)	;; owner euid and egid 
		 (shortunsigned gid)
		 (shortunsigned cuid)	;;creator euid and egid
		 (shortunsigned cgid)
		 (shortunsigned mode)  	;; lower 9 bits of access modes
		 (shortunsigned seq))  	;; sequence number
	 ipc_perm)

(typedef (struct) shm_desc)
(typedef (shm_desc *) shm_desc*)
(typedef longint time_t)
(typedef (longunsigned *) longunsigned*)
(typedef (struct (ipc_perm shm_perm)
		 (int shm_segsz)
		 (time_t shm_atime)
		 (time_t shm_dtime)
		 (time_t shm_ctime)
		 (shortunsigned shm_cpid)
		 (shortunsigned shm_lpid)
		 (short shm_nattch)
		 (shortunsigned shm_npages)
		 (longunsigned* shm_pages)
		 (shm_desc* attaches))
	 shmid_ds)

(typedef (shmid_ds *) shmid_ds*)

(extern int "shmctl" (int shmid) (int cmd) (shmid_ds* buf))

(extern Status "XShmQueryExtension"
	(Display* dpy))

(extern Status "XShmQueryVersion"
	(Display* dpy)
	(out int major)
	(out int minor)
	(out Bool pixmaps))

(extern int "XShmPixmapFormat"
	(Display* dpy))

(extern Status "XShmAttach"
	(Display* dpy)
	(XShmSegmentInfo* shminfo))

(extern Status "XShmDetach"
	(Display* dpy)
	(XShmSegmentInfo* shminfo))

(extern Status "XShmPutImage"
	(Display* dpy)
	(Drawable d)
	(GC gc)
	(XImage* image)
	(int src_x)
	(int src_y)
	(int dst_x)
	(int dst_y)
	(unsignedint src_width)
	(unsignedint src_height)
	(Bool send_event))

(extern Status "XShmGetImage"
	(Display* dpy)
	(Drawable d)
	(XImage* image)
	(int x)
	(int y)
	(unsignedlong plane_mask))

(extern XImage* "XShmCreateImage"
	(Display* dpy)
	(Visual* visual)
	(unsignedint depth)
	(int format)
	(char* data)
	(XShmSegmentInfo* shminfo)
	(unsignedint width)
	(unsignedint height))

(extern Pixmap "XShmCreatePixmap"
	(Display* dpy)
	(Drawable d)
	(char* data)
	(XShmSegmentInfo* shminfo)
	(unsignedint width)
	(unsignedint height)
	(unsignedint depth))
